#!/usr/bin/perl
# Show an applet for VNC access to a KVM system's console

require './server-manager-lib.pl';
use Socket;
&ReadParse();
$server = &get_managed_server($in{'id'});
$server || &error($text{'edit_egone'});
&can_action_error($server, "console");
$server->{'kvm_vnc_display'} ||
	&error($text{'vnc_ecannot'});
$server->{'status'} ne 'down' && $server->{'status'} ne 'nohost' ||
	&error($text{'vnc_edown'});
$server->{'manager'} eq 'kvm' || &error($text{'vnc_ekvm'});

&ui_print_header(&server_in($server), $text{'vnc_title'}, "");

# Get the VNC port
$vhost = &type_kvm_parent($server);
$port = 5900 + $server->{'kvm_vnc_display'};

# Check that the VNC port is really open on the KVM host, and connect to it
$err = undef;
&open_socket($vhost->{'ip'}, $port, VNCSOCK, \$err);
if ($err) {
	print &text('vnc_nolisten', $port, $vhost->{'host'}),"<p>\n";
	goto ENDPAGE;
	}

if ($vhost->{'id'} == 0) {
	# Special case - this box is the Xen host, so no forwarding needed
	$masterport = $port;
	close(VNCSOCK);
	}
else {
	# Pick a free port on the Cloudmin master, 5900+
	$masterport = 5900;
	$proto = getprotobyname('tcp');
	socket(VNCMASTER, PF_INET, SOCK_STREAM, $proto) ||
		&error("Socket failed : $!");
	setsockopt(VNCMASTER, SOL_SOCKET, SO_REUSEADDR, pack("l", 1));
	while(1) {
		last if (bind(VNCMASTER, sockaddr_in($masterport, INADDR_ANY)));
		$masterport++;
		}
	listen(VNCMASTER, SOMAXCONN);

	# Fork a listening process to forward VNC traffic
	if (!fork()) {
		# Wait for a connection
		untie(*STDIN); untie(*STDOUT);
		close(STDIN); close(STDOUT);
		$SIG{'ALRM'} = sub { exit(2) };
		alarm(30);
		$acptaddr = accept(VNCCLIENT, VNCMASTER);
		$acptaddr || exit(1);
		close(VNCMASTER);
		alarm(0);
		untie(*STDERR);
		close(STDERR);

		# Start forwarding traffic
		select(VNCCLIENT); $| = 1;
		select(VNCSOCK); $| = 1;
		&forward_connection_sockets(VNCCLIENT, VNCCLIENT,
					    VNCSOCK, VNCSOCK);
		exit;
		}
	close(VNCMASTER);
	close(VNCSOCK);
	}

# Ouput applet HTML
($masterhost) = split(/:/, $ENV{'HTTP_HOST'});
print &vnc_client_html($masterhost, $masterport, $server->{'kvm_vnc_passwd'},
		       \%in, $server, "kvnc.cgi");

ENDPAGE:
&ui_print_footer("edit_serv.cgi?id=$in{'id'}", $text{'edit_return'});

